<?php

class CategoryController extends AdmController {

    public function actionIndex() {
        $cate_id = (isset($_GET['cate_id'])) ? $_GET['cate_id'] : 0;

        $grids = $this->getGridData($cate_id);
        $this->render('index', array('grids' => $grids));
    }

    public function actionAjaxList() {
        
        $page = (isset($_GET['page'])) ? $_GET['page'] : 0;
        $id = (isset($_POST['id'])) ? $_POST['id'] : 0;

        $grids = $this->getGridData($id,'',$page);
        $this->renderPartial('index', array('grids' => $grids));
    }

    public function getGridData($id = 0, $txtsearch = '', $offset = 0) {
        Category::model()->categories($id);

        //insert doc to category
        //$models = Doc::model()->findAllByAttributes(array())
        $criteria = new CDbCriteria;
        $criteria->condition = "cate_id='$id'";
        //$criteria->order = "docdate desc, name asc";
        $criteria->order = "docno desc";
        $models = Doc::model()->findAll($criteria);
        foreach ($models as $r) {            
            $rowName = CHtml::encode($r->name);
            $docno = CHtml::encode($r->docno);
            $tabiancode = CHtml::encode($r->tabiancode);
            $sql = "insert into tmpcategory (rowid,parent_id,name,ctype,person_id, docdate, docno, tabiandate, tabiancode) values ";
            $sql.= "('$r->id','$r->cate_id','$rowName','1','$r->person_id','$r->docdate', '$docno', '$r->tabiandate', '$tabiancode')";
            Yii::app()->db->createCommand($sql)->execute();
        }

        $sql = "select * from tmpcategory";
        $count = Yii::app()->db->createCommand($sql)->execute();

        $pageSize = 1000;
        $pages = new CPagination($count);
        $pages->pageSize = $pageSize;
        $pages->route = 'ajaxList';
        if ($offset > 0) {
            $recordStart = ($offset * $pageSize) - $pageSize;
        } else {
            $recordStart = 0;
        }

        $sql.= " limit $recordStart,$pageSize";
        
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $navigation = Category::model()->showCatBreadCrumb($id);
        return array('models' => $models,
            'pages' => $pages,
            'count' => $count,
            'navigation' => $navigation,
            'parent_id' => $id);
    }

    public function actionAjaxCreate() {
        $model = new Category;
        $model->numlimit = '4';
        $model->yearmonth = '0';
        
        $pagetitle = 'ตั้งชื่อตู้เอกสาร';
        $this->renderPartial('_form', array('model' => $model, 'pagetitle' => $pagetitle));
    }

    public function actionAjaxUpdate() {
        $id = $_POST['id'];
        $model = Category::model()->findByPk($id);

        if (isset($_POST['save'])) {
            if ($id == '') {
                $model = new Category;
            }
            $model->name = $_POST['name'];
            $model->parent_id = $_POST['parent_id'];
            $model->prefix = $_POST['prefix'];
            $model->yearmonth = $_POST['yearmonth'];
            $model->numlimit = $_POST['numlimit'];
            $model->save();

            $msg = 0;
            $msgText = '';
            if (!$model->save()) {
                $msg = 1;
                $msgText = array_shift($model->getErrors());
            }
            $data = array('msg' => $msg, 'msgText' => $msgText);
            echo CJSON::encode($data);
            yii::app()->end();
        }

        $pagetitle = 'แก้ไขชื่อตู้เอกสาร';
        $this->renderPartial('_form', array('model' => $model, 'pagetitle' => $pagetitle));
    }

    public function actionAjaxDelete() {
        $id = $_POST['id'];

        $msgText = '';
        $models = Category::model()->findAllByAttributes(array('parent_id' => $id));
        if (count($models) > 0) {
            $msgText = 'ไม่สามารถลบได้เนื่องจาก ตู้เอกสารนี้มีตู้เอกสารย่อยอยู่ภายใน';
        } else {
            $models = Doc::model()->findAllByAttributes(array('cate_id' => $id));
            if (count($models) > 0) {
                $msgText = 'ไม่สามารถลบได้เนื่องจาก ตู้เอกสารนี้มีเอกสารอยู่ภายใน';
            } else {
                Category::model()->findByPk($id)->delete();
            }
        }

        //$msg = '0';
        //$row = Category::model()->findByPk($_POST['id']);
        //$row->delete();
        $data['msgText'] = $msgText;
        echo CJSON::encode($data);
    }

    //เรียกเมนูด้านข้าง
    public function actionAjaxListSideLeft() {
        $this->renderPartial('//layouts/side_left');
    }

}
