<?php

class DocController extends AdmController {

    public function actionIndex() {
        $cate_id = (isset($_GET['cate_id'])) ? (int) $_GET['cate_id'] : '0';
        $this->redirect(array('create', 'cate_id' => $cate_id));
    }

    public function actionCreate() {
        $cate_id = (int) $_GET['cate_id'];

        if ($cate_id != 0) {
            $model = new Doc;
            $model->cate_id = $cate_id;
            $model->tabiancode = Doc::model()->getDocrun($cate_id);
            $model->tabiandate = date('Y-m-d');
            $model->docdate = date('Y-m-d');
            $model->startdate = date('Y-m-d');
            $model->expdate = date('Y-m-d');
            $model->person_id = Yii::app()->user->id;

            $navigation = Category::model()->showCatBreadCrumb($cate_id, FALSE, 'เพิ่มแฟ้มใหม่');
            $this->render('form', array('model' => $model, 'navigation' => $navigation));
        }else {
            $this->render('//site/error',array('code'=>'No Category','message'=>'ต้องเลือกตู้เอกสารก่อน!!'));
        }
    }

    public function actionAjaxValidate() {
        $model = new Doc;
        $data = $model->checkDuplicate($_POST['id'], $_POST['tabiancode']);
        echo CJSON::encode($data);
    }

    public function actionUpdate() {
        $id = (isset($_GET['id'])) ? (int) $_GET['id'] : '0';
        $model = Doc::model()->findByPk($id);

        if (isset($_POST['Doc'])) {
            if ($_POST['id'] == '') {
                $model = new Doc;
                $model->cdate = date('Y-m-d');
                $model->ctime = date('H:i:s');
            } else {
                //submit มาจาก form
                $model = Doc::model()->findByPk($_POST['id']);
            }

            $model->attributes = $_POST['Doc'];
            $model->tabiandate = MyDate::dateToMysql($model->tabiandate);
            $model->docdate = MyDate::dateToMysql($model->docdate);
            $model->startdate = MyDate::dateToMysql($model->startdate);
            $model->expdate = MyDate::dateToMysql($model->expdate);
            $model->person_id = Yii::app()->user->id;
            if ($model->save()) {
                Yii::app()->user->setFlash('success', 'บันทึกข้อมูลเรียบร้อย');
                $this->redirect(array('update', 'id' => $model->id));
            } else {
                Yii::app()->user->setFlash('save_error', 'ไม่สามารถบันทึกข้อมูลได้เนื่องจาก ' . $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }

        $navigation = Category::model()->showCatBreadCrumb($model->cate_id, FALSE, 'แก้ไขแฟ้ม');
        $this->render('form', array('model' => $model, 'navigation' => $navigation));
    }

    public function actionAjaxDelete() {
        $id = $_POST['id'];

        $model = Doc::model()->findByPk($id);
        if ($model !== NULL) {
            $criteria = new CDbCriteria;
            $criteria->condition = "doc_id='$id'";

            $docfiles = Docfile::model()->findAll($criteria);
            foreach ($docfiles as $r) {
                $locationFile = Yii::getPathOfAlias('webroot') . '/' . $r->path . $r->filename;
                if ($model->delete()) {
                    if (file_exists($locationFile)) {
                        @unlink($locationFile);
                    }
                }
            }

            Yii::app()->db->createCommand("delete from tbdocfile where doc_id='$id'")->execute();
            Yii::app()->db->createCommand("delete from tbdoc_depart where doc_id='$id'")->execute();
            Yii::app()->db->createCommand("delete from tbdoc_person where doc_id='$id'")->execute();

            $model->delete();
        }
        echo true;
    }

    public function actionDetail() {
        if (isset($_GET['id'])) {
            $id = (int) $_GET['id'];
            $modal = FALSE;
        } else {
            $id = $_POST['id'];
            $modal = TRUE;
        }

        $model = Doc::model()->findByPk($id);
        $navigation = Category::model()->showCatBreadCrumb($model->cate_id, FALSE, 'รายละเอียด', !$modal);

        if ($modal) {
            $this->renderPartial('detail', array('model' => $model, 'navigation' => $navigation, 'modal' => $modal));
        } else {
            $this->render('detail', array('model' => $model, 'navigation' => $navigation, 'modal' => $modal));
        }
    }

    public function actionAjaxDocRun() {
        $cate_id = (int) $_POST['cate_id'];
        $data['docno'] = Doc::model()->getDocrun($cate_id);
        echo CJSON::encode($data);
    }

}

?>