<?php

class DocfileController extends AdmController {

    public function actionIndex() {
        $this->redirect(array('category'));
    }

    public function actionAjaxList() {
        $doc_id = $_POST['doc_id'];
        $grids = $this->getGridData($doc_id);
        $this->renderPartial('//doc/_gridview_file', array('grids' => $grids));
    }

    public function getGridData($docid = '') {
        $criteria = new CDbCriteria;
        $criteria->condition = "doc_id=:docid";
        $criteria->params = array(':docid' => "$docid");
        $criteria->order = 'oldfilename asc';

        $models = Docfile::model()->findAll($criteria);

        $count = count($models);
        return array('models' => $models, 'count' => $count);
    }

    public function actionAjaxUpload() {
        $data = array();
        if (isset($_GET['files'])) {
            $error = false;
            $files = array();

            $doc_id = $_POST['doc_id'];
            $dirArray = Docfile::model()->createDir();
            foreach ($_FILES as $file) {
                $filename = basename($file['name']);
                $newFileName = $doc_id . '_' . date('YmdHis') . '.' . pathinfo($file['name'], PATHINFO_EXTENSION);
                if (move_uploaded_file($file['tmp_name'], $dirArray['upload_dir'] . $newFileName)) {
                    $files[] = $dirArray['upload_dir'] . $file['name'];

                    $model = new Docfile;
                    $model->doc_id = $doc_id;
                    $model->oldfilename = $filename;
                    $model->filename = $newFileName;
                    $model->path = $dirArray['folder'];
                    $model->comment = ($_POST['comment'] == '') ? $filename : $_POST['comment'];
                    //$model->comment = pathinfo($file['name'], PATHINFO_EXTENSION);
                    $model->save();
                } else {
                    $error = true;
                }
            }
            $data = ($error) ? array('error' => 'There was an error uploading your files') : array('files' => $files);
        } else {
            $data = array('success' => 'Form was submitted', 'formData' => $_POST);
        }

        echo json_encode($data);
    }

    public function actionAjaxDelete() {
        $id = $_POST['id'];
        $model = Docfile::model()->findByPk($_POST['id']);

        $msgText = '';
        if ($model !== NULL) {
            $locationFile = Yii::getPathOfAlias('webroot') . '/' . $model->path . $model->filename;
            if ($model->delete()) {
                if (file_exists($locationFile)) {
                    @unlink($locationFile);
                }
            }
        }
        $data['msgText'] = $msgText;
        echo CJSON::encode($data);
    }

    public function actionDownload() {
        $idfile = base64_decode($_GET['file']);
        $docfile = Docfile::model()->findByPk($idfile);

        $downloadFile = Yii::app()->request->baseUrl . "/" . $docfile->path . $docfile->filename;
        $ext_file = explode(".", $docfile->filename);
        $ext_file = $ext_file[count($ext_file) - 1];

        $file = Yii::getPathOfAlias("webroot") . '/' . $docfile->path . $docfile->filename;
        if (file_exists($file)) {
            /*
              header('Content-Description: File Transfer');
              header('Content-Type: application/octet-stream');
              header('Content-Disposition: attachment; filename=' . $docfile->oldfilename);
              header('Expires: 0');
              header('Cache-Control: must-revalidate');
              header('Pragma: public');
              header('Content-Length: ' . filesize($file));
              readfile($file);
              exit;
             * 
             */

            header("Content-type: application/$ext_file");
            header('Content-Disposition: inline; filename="' . $docfile->oldfilename . '"');
            header('Content-Length: ' . filesize($file));
            @readfile($file);
            exit;
        }
    }

}
