<?php

class GroupController extends AdmController {

    public function actionIndex() {
        $grids = $this->getGridData();
        $this->render('index', array('grids' => $grids));
    }

    public function actionAjaxList() {
        $grids = $this->getGridData($_POST['txtsearch']);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($txtsearch = '') {
        $criteria = new CDbCriteria;
        $criteria->condition = "name LIKE :txtsearch";
        $criteria->params = array(':txtsearch' => "%$txtsearch%");
        $criteria->order = 'name asc';

        $count = Group::model()->count($criteria);

        $pages = new CPagination($count);
        $pages->route = 'ajaxList';
        $pages->pageSize = Yii::app()->params['pageSize'];
        $pages->applyLimit($criteria);
        $models = Group::model()->findAll($criteria);

        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionCreate() {
        $model = new Group;

        $pagetitle = "เพิ่มกลุ่มผู้ใช้งาน";
        $this->render('form', array('model' => $model, 'pagetitle' => $pagetitle));
    }

    public function actionAjaxValidate() {
        $data = Group::model()->checkDuplicate($_POST['id'], $_POST['name']);
        echo CJSON::encode($data);
    }

    public function actionUpdate() {
        $id = (isset($_GET['id'])) ? (int) $_GET['id'] : '0';
        $model = Group::model()->findByPk($id);

        if (isset($_POST['Group'])) {
            if ($_POST['id'] == '') {
                $model = new Group;
            } else {
                //submit มาจาก form
                $model = Group::model()->findByPk($_POST['id']);
            }

            $model->attributes = $_POST['Group'];

            if ($model->save()) {
                $menus = Menu::model()->findAll();
                $group_id = $model->id;
                foreach ($menus as $r) {
                    if ($r->id == '1' || $r->id == '5') {
                        $ck_view = '1';
                    } else {
                        $ck_view = (@$_POST['view_' . $r->id] == 'on') ? '1' : '0';
                    }
                    
                    $ck_save = (@$_POST['save_' . $r->id] == 'on') ? '1' : '0';
                    $ck_del = (@$_POST['del_' . $r->id] == 'on') ? '1' : '0';
                    
                    $permis = GroupPermis::model()->findByAttributes(array(
                        'group_id' => $group_id,
                        'menu_id' => $r->id
                    ));

                    if ($permis === NULL) {
                        $permis = new GroupPermis;
                    }

                    $permis->group_id = $group_id;
                    $permis->menu_id = $r->id;
                    $permis->ck_view = $ck_view;
                    $permis->ck_save = $ck_save;
                    $permis->ck_del = $ck_del;
                    $permis->save();
                }

                Yii::app()->user->setFlash('success', 'บันทึกข้อมูลเรียบร้อย');
                $this->redirect(array('update', 'id' => $model->id));
            } else {
                Yii::app()->user->setFlash('save_error', 'ไม่สามารถบันทึกข้อมูลได้เนื่องจาก ' . $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }

        $pagetitle = "แก้ไขกลุ่มผู้ใช้งาน";
        $this->render('form', array('model' => $model, 'pagetitle' => $pagetitle));
    }

    public function actionAjaxDelete() {
        $id = $_POST['id'];
        $msg = '0';
        $row = Group::model()->findByPk($id);

        if ($row->delete()) {
            Yii::app()->db->createCommand("delete from tbgroup_permis where group_id='$id'")->execute();
        }
        $data['msg'] = $msg;
        echo CJSON::encode($data);
    }

}
