<?php

class PersonController extends AdmController {

    public function actionIndex() {
        $txtsearch = Yii::app()->session['person_txtsearch'];
        
        $grids = $this->getGridData($txtsearch);
        $this->render('index', array('grids' => $grids,'txtsearch'=>$txtsearch));
    }

    public function actionAjaxList() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;
        Yii::app()->session['person_txtsearch'] = $_POST['txtsearch'];

        $grids = $this->getGridData($_POST['txtsearch'],$offset);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($txtsearch = '', $offset = 0) {
        $sql = "SELECT tbperson.id, tbperson.`code`, tbperson.title, tbperson.firstname, tbperson.surname, ";
        $sql.= " tbgroup.`name` as group_name, tbdepart.`name` as depart_name, tbperson.status, tbperson.username";
        $sql.= " FROM tbperson LEFT JOIN tbdepart ON tbperson.depart_id = tbdepart.id ";
        $sql.= " LEFT JOIN tbgroup ON tbperson.group_id = tbgroup.id";
        $sql.= " WHERE (tbperson.code LIKE '%$txtsearch%') or (tbgroup.name LIKE '%$txtsearch%') or (tbdepart.name LIKE '%$txtsearch%') ";
        $sql.= " or (CONCAT(tbperson.title,tbperson.firstname,' ',tbperson.surname) LIKE '%$txtsearch%') or (tbperson.username LIKE '%$txtsearch%')"; 

        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxList';

        $pageLimit = Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql.= " Order By tbperson.code asc";
        $sql.= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionCreate() {
        $model = new Person;

        $pagetitle = "แก้ไขผู้ใช้งาน";
        $this->render('form', array('model' => $model, 'pagetitle' => $pagetitle));
    }

    public function actionAjaxValidate() {
        $data = Person::model()->checkDuplicate($_POST['id'], $_POST['code']);
        echo CJSON::encode($data);
    }

    public function actionUpdate() {
        $id = (isset($_GET['id'])) ? (int) $_GET['id'] : '0';
        $model = Person::model()->findByPk($id);

        if (isset($_POST['Person'])) {
            if ($_POST['id'] == '') {
                $model = new Person;
            } else {
                //submit มาจาก form
                $model = Person::model()->findByPk($_POST['id']);
            }

            $model->attributes = $_POST['Person'];
            if($_POST['pwd']!==''){
                $model->pwd = MyFn::hashPassword($_POST['pwd']);
            }

            if ($model->save()) {
                Yii::app()->user->setFlash('success', 'บันทึกข้อมูลเรียบร้อย');
                $this->redirect(array('update', 'id' => $model->id));
            } else {
                Yii::app()->user->setFlash('save_error', 'ไม่สามารถบันทึกข้อมูลได้เนื่องจาก ' . $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }

        $pagetitle = "แก้ไขผู้ใช้งาน";
        $this->render('form', array('model' => $model, 'pagetitle' => $pagetitle));
    }

    public function actionAjaxDelete() {
        $id = $_POST['id'];
        $msg = '0';
        $row = Person::model()->findByPk($id);

        $row->delete();
        $data['msg'] = $msg;
        echo CJSON::encode($data);
    }

    public function actionAjaxListModal() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        $txtsearch = $_POST['txtsearch'];

        $grids = $this->getGridDataModal($txtsearch, $offset);
        $this->renderPartial('_gridview_modal', array('grids' => $grids,
            'txtsearch' => $txtsearch));
    }

    public function getGridDataModal($txtsearch = '', $offset = 0) {
        $sql = "select id, code, title, firstname, surname, status from tbperson";
        $sql.= " Where (`code` LIKE '%$txtsearch%') or (CONCAT(title,firstname,' ',surname) LIKE '%$txtsearch%')";
        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxListModal';

        $pageLimit = Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql.= " Order By code asc";
        $sql.= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

}
