<form id='formUploadFile' action="<?php echo Yii::app()->createUrl('doc/ajaxUpload'); ?>" 
      onSubmit="return false" 
      method="post" enctype="multipart/form-data" 
      id="MyUploadForm"
      class='form-horizontal'>

    <input type='hidden' id='doc_id' name='doc_id' value='<?php echo $doc_id; ?>'/>
    <div class="form-group">
        <label class="col-md-2 control-label">เลือกไฟล์</label>
        <div class="col-md-10">
            <input type="file" id='file_upload' name="file_upload"/>
        </div>
    </div>

    <div class="form-group">
        <label class="col-md-2 control-label">คำอธิบาย</label>
        <div class="col-md-6">
            <input type="text" id='comment' name="comment" maxlength="100" class='form-control'/>
        </div>
    </div>

    <div class="form-group">
        <label class="col-md-2 control-label"></label>
        <div class="col-md-10">
            <button type="submit" id="submit-btn" class="btn btn-primary"><i class='fa fa-upload'></i> อัพโหลด</button>
            <div class="text-muted">[อัพโหลดไฟล์ได้ครั้งละไม่เกิน <strong><?php echo ini_get('memory_limit');?></strong>]</div>
        </div>
    </div>
</form>
<div class="clearfix"></div>

<div id='divGridDocFile'></div>

<script type="text/javascript">
    $(function () {
        // Variable to store your files
        var files;

        // Add events
        $('input[type=file]').on('change', prepareUpload);
        $('#formUploadFile').on('submit', uploadFiles);

        // Grab the files and set them to our variable
        function prepareUpload(event) {
            files = event.target.files;
        }

        // Catch the form submit and upload the files
        function uploadFiles(event) {
            if (!$('#file_upload').val()) {
                wrapDialog('คุณต้องเลือกไฟล์ที่ต้องการอัพโหลดก่อน!!', 'danger');
                return false;
            }

            event.stopPropagation(); // Stop stuff happening
            event.preventDefault(); // Totally stop stuff happening

            // START A LOADING SPINNER HERE

            // Create a formdata object and add the files
            var data = new FormData();
            $.each(files, function (key, value) {
                data.append(key, value);
            });

            data.append('doc_id', $('#doc_id').val());
            data.append('comment', $('#comment').val());
            $.ajax({
                url: '<?php echo Yii::app()->createUrl('docfile/ajaxUpload'); ?>&files',
                type: 'POST',
                data: data,
                cache: false,
                dataType: 'json',
                processData: false, // Don't process the files
                contentType: false, // Set content type to false as jQuery will tell the server its a query string request
                success: function (data, textStatus, jqXHR) {
                    if (typeof data.error === 'undefined')
                    {
                        // Success so call function to process the form
                        submitForm(event, data);
                    } else {
                        // Handle errors here
                        wrapDialog('ERRORS: ' + data.error, 'danger');
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    // Handle errors here
                    wrapDialog('ERRORS: ' + textStatus, 'danger');
                    // STOP LOADING SPINNER
                }
            });
        }

        function submitForm(event, data) {
            // Create a jQuery object from the form
            $form = $(event.target);

            // Serialize the form data
            var formData = $form.serialize();

            // You should sterilise the file names
            $.each(data.files, function (key, value) {
                formData = formData + '&filenames[]=' + value;
            });

            $.ajax({
                url: '<?php echo Yii::app()->createUrl('docfile/ajaxUpload'); ?>',
                type: 'POST',
                data: formData,
                cache: false,
                dataType: 'json',
                success: function (data, textStatus, jqXHR) {
                    if (typeof data.error === 'undefined') {
                        // Success so call function to process the form
                        wrapDialog('อัพโหลดไฟล์สำเร็จ');
                        $('#file_upload').val('');
                        $('#comment').val('');
                        loadDivGridDocFile();
                    } else {
                        // Handle errors here
                        wrapDialog('ERRORS: ' + data.error), 'danger';
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    // Handle errors here
                    wrapDialog('ERRORS: ' + textStatus), 'danger';
                },
                complete: function () {
                    // STOP LOADING SPINNER
                }
            });
        }

        loadDivGridDocFile();
    });

    function loadDivGridDocFile(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('docfile/ajaxList') ?>";
        var p = {};
        p['doc_id'] = $('#id').val();

        $('#divGridDocFile').load(url, p);
        return true;
    }

    function delDocFile(id) {
        BootstrapDialog.show({
            type: BootstrapDialog.TYPE_WARNING,
            title: 'ลบข้อมูล',
            message: 'คุณต้องการลบไฟล์นี้ใช่หรือไม่',
            buttons: [{
                    label: 'ไม่',
                    cssClass: 'btn-default',
                    action: function (dialog) {
                        dialog.close();
                    }
                }, {
                    label: 'ใช่,ลบทันที',
                    cssClass: 'btn-danger',
                    action: function (dialog) {
                        dialog.close();

                        var p = {};
                        p['id'] = id;
                        $.ajax({
                            data: p,
                            url: "<?php echo Yii::app()->createUrl('docfile/ajaxDelete') ?>",
                            type: 'POST',
                            dataType: 'json',
                            success: function (data) {
                                if (data.msgText != '') {
                                    wrapDialog(data.msgText);
                                } else {
                                    loadDivGridDocFile();
                                }
                            },
                            error: function () {
                                wrapDialog('Error: ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง', 'danger');
                            }
                        });
                    }
                }]
        });

        return true;
    }
</script>

