<?php
require_once(Yii::getPathOfAlias('webroot.protected.views.doc.lang') . '/th.php');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/dist/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/dist/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/dist/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/dist/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/dist/js/input-mask/jquery.inputmask.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/dist/js/input-mask/jquery.inputmask.date.extensions.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/dist/js/input-mask/jquery.inputmask.extensions.js', CClientScript::POS_END);

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/dist/js/jquery.form.min.js');

$this->pageTitle = Yii::app()->name . ' แฟ้มเอกสาร';
$this->renderPartial('//layouts/hasFlash');
$permisFile = Person::model()->getPermis(5);
?>
<div class="box box-primary">
    <div class="box-header with-border">
        <div class="box-title"><?php echo $navigation; ?></div>
        <?php if ($permisFile->ck_save == '1'): ?>
            <div class="pull-right">
                <a href='<?php echo Yii::app()->createUrl('/doc/index', array('cate_id' => $model->cate_id)); ?>' class='btn btn-default'><i class='fa fa-plus'></i> สร้างแฟ้มใหม่</a>
            </div><!-- /.box-tools -->
        <?php endif; ?>
        <div class='clearfix'></div>
    </div><!-- /.box-header -->
</div>
<div class="nav-tabs-custom">
    <ul class="nav nav-tabs">
        <li class="active"><a href="#tab_1" data-toggle="tab"><i class='fa fa-briefcase'></i> ข้อมูลแฟ้ม</a></li>
        <li><a href="#tab_2" data-toggle="tab"><i class='fa fa-upload'></i> อัพโหลดไฟล์</a></li>
        <li><a href="#tab_3" data-toggle="tab"><i class='fa fa-share-alt'></i> แชร์ให้แผนก</a></li>
        <li><a href="#tab_4" data-toggle="tab"><i class='fa fa-user'></i> แชร์ให้บุคคล/ไม่แชร์</a></li>
    </ul>
    <div class="tab-content">
        <div class="tab-pane active" id="tab_1">
            <?php
            $form = $this->beginWidget('CActiveForm', array(
                'id' => 'myform',
                'enableClientValidation' => false,
                'enableAjaxValidation' => false,
                'htmlOptions' => array(
                    'class' => 'form-horizontal',
                ),
                'action' => Yii::app()->createUrl('doc/update'), //<- your form action here
            ));
            echo $form->hiddenField($model, 'cate_id');
            ?>

            <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
            <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

            <div class="form-group">
                <label class="col-md-2 control-label"><?php echo $lang['Doc_name']; ?><span class="required">*</span></label>
                <div class="col-md-10">
                    <?php
                    echo $form->textField($model, 'name', array('class' => 'form-control', 'required' => 'true', 'autofocus' => 'true'));
                    ?>
                </div>
            </div>

            <div class="form-group">
                <label class="col-md-2 control-label"><?php echo $lang['Doc_tabiancode']; ?></label>
                <div class="col-md-4">
                    <div class="input-group">
                        <?php echo $form->textField($model, 'tabiancode', array('class' => 'form-control')); ?>
                        <span class="input-group-btn">
                            <button type="button" class="btn btn-default" onclick="docrun()"><i class="fa fa-flash"></i></button>
                        </span>
                    </div>
                </div>

                <label class="col-md-2 control-label"><?php echo $lang['Doc_tabiandate']; ?><span class="required">*</span></label>
                <div class="col-md-3">
                    <div class="input-group date">
                        <?php
                        $model->tabiandate = MyDate::dateToText($model->tabiandate);
                        echo $form->textField($model, 'tabiandate', array('class' => 'form-control', 'placeholder' => 'วว/ดด/ปี พ.ศ.', 'required' => 'true'));
                        ?>
                        <span class="input-group-addon btn btn-primary"><span class="fa fa-calendar"></span></span>
                    </div>
                </div>
            </div>

            <div class="form-group">
                <label class="col-md-2 control-label"><?php echo $lang['Doc_docno']; ?></label>
                <div class="col-md-4">
                    <?php echo $form->textField($model, 'docno', array('class' => 'form-control')); ?>
                </div>

                <label class="col-md-2 control-label"><?php echo $lang['Doc_docdate']; ?><span class="required">*</span></label>
                <div class="col-md-3">
                    <div class="input-group date">
                        <?php
                        $model->docdate = MyDate::dateToText($model->docdate);
                        echo $form->textField($model, 'docdate', array('class' => 'form-control', 'placeholder' => 'วว/ดด/ปี พ.ศ.', 'required' => 'true'));
                        ?>
                        <span class="input-group-addon btn btn-primary"><span class="fa fa-calendar"></span></span>
                    </div>
                </div>
            </div>

            <div class="form-group">
                <label class="col-md-2 control-label">สถานะ</label>
                <div class="col-md-3">
                    <?php echo $form->dropDownList($model, 'status', array('0' => 'เผยแพร่', '1' => 'ระงับการเผยแพร่', '2' => 'กำหนดวันหมดอายุ'), array('class' => 'form-control')); ?>
                </div>
            </div>

            <div class="form-group" id="div_startdate">
                <label class="col-md-2 control-label">เริ่มเผยแพร่</label>
                <div class="col-md-3">
                    <div class="input-group date">
                        <?php
                        $model->startdate = MyDate::dateToText($model->startdate);
                        echo $form->textField($model, 'startdate', array('class' => 'form-control', 'placeholder' => 'วว/ดด/ปี พ.ศ.'));
                        ?>
                        <span class="input-group-addon btn btn-primary"><span class="fa fa-calendar"></span></span>
                    </div>
                </div>
            </div>

            <div class="form-group" id="div_expdate">
                <label class="col-md-2 control-label">วันที่หมดอายุ</label>
                <div class="col-md-3">
                    <div class="input-group date">
                        <?php
                        $model->expdate = MyDate::dateToText($model->expdate);
                        echo $form->textField($model, 'expdate', array('class' => 'form-control', 'placeholder' => 'วว/ดด/ปี พ.ศ.'));
                        ?>
                        <span class="input-group-addon btn btn-primary"><span class="fa fa-calendar"></span></span>
                    </div>
                </div>
            </div>

            <div class="form-group">
                <label class="col-md-2 control-label">คำอธิบาย/คำค้น</label>
                <div class="col-md-10">
                    <?php echo $form->textArea($model, 'comment', array('rows' => 4, 'class' => 'form-control')); ?>
                </div>
            </div>

            <div class="form-group">
                <label class="col-md-2 control-label">ผู้บันทึก</label>
                <div class="col-md-4">
                    <input type='text' class="form-control" readonly="true" value="<?php echo $model->person->username . " (" . $model->person->title . $model->person->firstname . " " . $model->person->surname . ")"; ?>" tabindex="-1"/>
                </div>
            </div>

            <?php if ($permisFile->ck_save == '1'): ?>
                <div class="box-footer margin-top-40">
                    <div class="text-center">
                        <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                            <i class="fa fa-save"></i>
                            บันทึกข้อมูล
                        </button>
                    </div>
                </div>
            <?php endif; ?>
            <?php $this->endWidget(); ?>
        </div>      <!-- end tab_1 -->

        <div class="tab-pane" id="tab_2">
            <?php
            if ($model->id == '') {
                echo '<div class="callout callout-info">
                        <h4>คุณต้องบันทึกข้อมูลแฟ้มก่อน จึงจะอัพโหลดไฟล์ได้</h4>
                      </div>';
            } else {
                $this->renderPartial('_formupload', array('doc_id' => $model->id));
            }
            ?>
        </div>      <!-- end tab_2 -->

        <div class="tab-pane" id="tab_3">
            <?php
            if ($model->id == '') {
                echo '<div class="callout callout-info">
                        <h4>คุณต้องบันทึกข้อมูลแฟ้มก่อน จึงจะแชร์ให้แผนกได้</h4>
                      </div>';
            }
            ?>
        </div>      <!-- end tab_3 -->

        <div class="tab-pane" id="tab_4">
            <?php
            if ($model->id == '') {
                echo '<div class="callout callout-info">
                        <h4>คุณต้องบันทึกข้อมูลแฟ้มก่อน จึงจะแชร์ให้บุคคล/ไม่แชร์ได้</h4>
                      </div>';
            }
            ?>
        </div>      <!-- end tab_4 -->
    </div>  <!-- end TabContent -->
</div>

<!-- Modal edit Person -->
<div class="modal fade colored-header" id="myModalEditPerson" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<!-- Modal Person -->
<?php $this->renderPartial('//person/modalPerson'); ?>
<script type='text/javascript'>
    $(document).ready(function () {
        $('#myform').validate();

        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            orientation: "top auto",
            format: "dd/mm/yyyy"
        });

        $(".input-group.date input").inputmask("dd/mm/yyyy", {"placeholder": "วว/ดด/ปปปป"});

        if ($('#id').val() !== '') {
            loadDepart();
            loadPerson();
        }

        $('#Doc_status').on('change', function () {
            doDocStatus();
        });
        doDocStatus();
    });

    function doDocStatus() {
        switch ($('#Doc_status').val()) {
            case '0':
                $('#div_startdate').show();
                $('#div_expdate').hide();
                break;
            case '1':
                $('#div_startdate').hide();
                $('#div_expdate').hide();
                break;
            case '2':
                $('#div_startdate').show();
                $('#div_expdate').show();
                break;
        }
    }

    function save() {
        scrollToTop();
        loadingStatic();
        $('#myform').submit();
    }

    function save_() {
        var p = {};
        p['save'] = true;
        p['id'] = $('#id').val();
        p['tabiancode'] = $('#Doc_tabiancode').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('doc/ajaxValidate') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                scrollToTop();
                if (data.msg == '0') {
                    loadingStatic();
                    $('#myform').submit();
                } else {
                    wrapDialog(data.msgText, 'danger');
                }
            },
            error: function () {
                wrapDialog('Error: ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!', 'danger');
            }
        });
        return true;
    }

    //load depart and doc_depart
    function loadDepart() {
        var p = {};
        p['doc_id'] = $('#id').val();

        $('#tab_3').load("<?php echo Yii::app()->createUrl('docdepart/ajaxList') ?>", p);
        return true;
    }

    //load person
    function loadPerson() {
        var p = {};
        p['doc_id'] = $('#id').val();

        $('#tab_4').load("<?php echo Yii::app()->createUrl('docperson/ajaxList') ?>", p);
        return true;
    }

    //เปิด Modal Person
    function personModal() {
        loadGridPersonModal();
        $('.modal').on('shown.bs.modal', function () {
            $('#txtsearchPersonModal').focus();
        });
        $('#myModalPerson').modal({show: true});
    }

    //เลือกหมวดจาก modal
    function personModalSelect(id, code) {
        $('#person_id').val(id);
        $('#person_name').val(code);
        $('#myModalPerson').modal('hide');
    }

    //รันเลขที่เอกสาร
    function docrun() {
        var p = {};
        p['cate_id'] = $('#Doc_cate_id').val();
        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('doc/ajaxDocRun') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                $('#Doc_tabiancode').val(data.docno);
            },
            error: function () {
                wrapDialog('Error: ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!', 'danger');
            }
        });

        return true;
    }
</script>