<?php
require_once(Yii::getPathOfAlias('webroot.protected.views.doc.lang') . '/th.php');
$permisFile = Person::model()->getPermis(5);
?>
<div class="box">
    <div class="box-header with-border">
        <div class="box-title">ผลการค้นหา<?php echo $titlebox; ?></div>
    </div><!-- /.box-header -->

    <div class='box-body no-padding'>
        <div class="mailbox-messages table-responsive">
            <table class="table table-hover table-striped">
                <tbody>
                    <tr>
                        <th class='text-center th-bg' width='40'>#</th>
                        <th class='th-bg'><?php echo $lang['Doc_docdate']; ?></th>
                        <th class='th-bg'><?php echo $lang['Doc_name']; ?></th>
                        <th class='th-bg'><?php echo $lang['Doc_docno']; ?></th>
                        <th class='th-bg'><?php echo $lang['Doc_tabiancode']; ?></th>
                        <th class='th-bg'><?php echo $lang['Doc_tabiandate']; ?></th>
                        <th class='th-bg'></th>
                    </tr>
                    <?php
                    $models = $grids['models'];
                    $irow = 0;
                    foreach ($models as $r) {
                        $irow++;
                        $ret = ($r['person_id'] == Yii::app()->user->id) ? TRUE : FALSE;

                        echo "<tr>";
                        echo "<td class='text-center'>$irow.</td>";
                        echo "<td>" . MyDate::dateToText($r['docdate']) . "</td>";
                        echo '<td><a href="#" onclick="return showDetail(\'' . $r['rowid'] . '\')">' . $r['name'] . '</a></td>';
                        echo "<td>" . $r['docno'] . "</td>";
                        echo "<td>" . $r['tabiancode'] . "</td>";
                        echo "<td>" . MyDate::dateToText($r['tabiandate']) . "</td>";
                        echo '<td class="text-center nowrap">';

                        echo '<div class="btn-group">';
                        echo '<button data-toggle="dropdown" class="btn btn-default dropdown-toggle btn-sm" type="button" aria-expanded="false">...</button>';
                        echo '<ul class="dropdown-menu pull-right">';
                        echo '<li><a href="#" onclick="return showDetail(\'' . $r['rowid'] . '\')"><i class="fa fa-eye"></i> แสดง</a></li>';

                        if ($r['person_id'] == Yii::app()->user->id) {  //แก้ไข ลบ ได้เฉพาะเอกสารที่ตัวเองสร้างเท่านั้น
                            if ($permisFile->ck_save == '1' || $ret) {
                                echo '<li>' . CHtml::link('<i class="fa fa-pencil"></i> แก้ไข', array("doc/update", "id" => $r['rowid'])) . '</li>';
                            }

                            if ($permisFile->ck_del == '1' || $ret) {
                                echo '<li><a href="#" onclick="return delDoc(\'' . $r['rowid'] . '\')"><i class="fa fa-trash-o"></i> ลบ</a></li>';
                            }
                        }

                        echo '</ul>';
                        echo '</div>';
                    }
                    echo "</td>";
                    echo "</tr>";

                    if ($irow == 0) {
                        echo "<tr><td colspan='4' class='text-center'>*** ไม่พบข้อมูลการค้นหาตามเงื่อนไข ***</td></tr>";
                    }
                    ?>
                </tbody>
            </table>
        </div>
    </div>  <!-- end box-body -->

    <div class="box-footer">
        <div class="pull-left">
            <?php
            $this->widget('CLinkPager', array(
                'htmlOptions' => array(
                    'class' => 'pagination pagination-sm no-margin',
                ),
                'pages' => $grids['pages'],
                'header' => '',
                'firstPageLabel' => '<<',
                'prevPageLabel' => "<",
                'nextPageLabel' => '>',
                'lastPageLabel' => '>>',
            ));
            ?>
        </div>
        <div class='pull-right'>
            ค้นเจอทั้งหมด <strong><?php echo number_format($grids['count']); ?></strong> รายการ
        </div>
        <div class="clearfix"></div>
    </div><!-- end box-footer -->

</div>

<!-- Modal -->
<div class="modal fade" id="myModalDetail" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>
<script type='text/javascript'>
    $(function () {
        $(".pagination").on("click", 'a', function (event) {
            event.preventDefault();
            var url = $(this).attr("href");
            if (url != undefined) {
                loadContent(url);
            }
            return true;
        });


        $('.table-responsive .dropdown-toggle').on('click', function () {
            var button = $(this),
                    menu = button.next('.dropdown-menu');

            menu.css({
                position: 'fixed',
                top: button.offset().top + button.outerHeight() - $(window).scrollTop(),
                right: $(window).width() - (button.offset().left + button.outerWidth())
            });

            $(window).on('scroll', function () {
                menu.css({
                    top: button.offset().top + button.outerHeight() - $(window).scrollTop()
                });
            });

            $(window).on('resize', function () {
                $('.dropdown-backdrop').trigger('click');
                button.blur();
                $(window).off('resize scroll');
            });
        });

    });

    function loadContent(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('search/ajaxList') ?>";
        var p = {};
        p['txtsearch'] = $('#navbar-search-input').val();
        $('#contentCol').load(url, p);
        return true;
    }

    function showDetail(id) {
        var p = {};
        p['id'] = id;
        p['modal'] = true;
        $('#myModalDetail').load("<?php echo Yii::app()->createUrl('doc/detail') ?>", p, function () {
            $('#myModalDetail').modal('show');
        });
        return true;
    }

    //ลบแฟ้มเอกสาร
    function delDoc(id) {
        BootstrapDialog.show({
            type: BootstrapDialog.TYPE_WARNING,
            title: 'ลบข้อมูล',
            message: 'คุณต้องการลบไฟล์นี้ใช่หรือไม่',
            buttons: [{
                    label: 'ไม่',
                    cssClass: 'btn-default',
                    action: function (dialog) {
                        dialog.close();
                    }
                }, {
                    label: 'ใช่,ลบทันที',
                    cssClass: 'btn-danger',
                    action: function (dialog) {
                        dialog.close();

                        var p = {};
                        p['id'] = id;
                        $.ajax({
                            data: p,
                            url: "<?php echo Yii::app()->createUrl('doc/ajaxDelete') ?>",
                            type: 'POST',
                            dataType: 'json',
                            success: function () {

                                loadContent();
                            },
                            error: function () {
                                wrapDialog('Error: ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง', 'danger');
                            }
                        });
                    }
                }]
        });

        return true;
    }
</script>